import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.Vector;

public class Pildike4 extends Applet implements Runnable, KeyListener{
  Image taust;
  Image pilt;
  Graphics piltg;
  Image lill, lill2;
  int lillekorgus=100;
  Image putukas;
  int putukax=100, putukay=150;
  int putukalaius=30, putukakorgus=15;
  int putukasamm=4;
  int imemiskaugus=10;
  int mustripikkus=160;
  int samm=1;
  int paus=50;
  int nihe=0; 
  int aeg=0;
  int laius=300, korgus=300;
  Vector lillekesed=new Vector();
  double lillelisamistoenaosus=0.03*samm;

  boolean veel=false;
  
  public Pildike4(){
    addKeyListener(this);
  }
  public void paint(Graphics g){
    koostaPilt();
    g.drawImage(pilt, 0, 0, this);
  }
  public void update(Graphics g){
    paint(g);
  }

  void koostaPilt(){
    if(taust==null)taust=laePilt("rohetaust320x480.gif");
    if(putukas==null)putukas=laePilt("sirelane.gif");
    if(lill==null)lill=laePilt("lill1a.gif");
    if(lill2==null)lill2=laePilt("lill1.gif");
    if(pilt==null){
      pilt=createImage(laius, korgus);    
      piltg=pilt.getGraphics();
    }
    nihe=nihe+samm;
    aeg=aeg+samm;
    if(nihe>mustripikkus)nihe=nihe-mustripikkus;
    eemaldaVanadLilled();
    lisaUusiLilli();
    kontrolliImemisi();
    piltg.drawImage(taust, 0, nihe-mustripikkus, this);
    joonistaLilled();
    piltg.drawImage(putukas, putukax, putukay, this);
  }
  
  void lisaUusiLilli(){
   for(double lt=lillelisamistoenaosus; lt>0; lt=lt-1){
    if(Math.random()<lt){
      lillekesed.addElement(new Lilleke4((int)((laius-10)*Math.random()), aeg));
    }
   }
  }
  
  void eemaldaVanadLilled(){
    for(int i=0; i<lillekesed.size(); i++){
      Lilleke4 l=(Lilleke4)lillekesed.elementAt(i); 
      if(aeg-l.algaeg>korgus+lillekorgus){
        lillekesed.removeElementAt(i);
        i--;
      }    
    }
  }
  
  void kontrolliImemisi(){
    int kauguseruut=imemiskaugus*imemiskaugus;
    for(int i=0; i<lillekesed.size(); i++){
      Lilleke4 l=(Lilleke4)lillekesed.elementAt(i);
      int lilley=aeg-l.algaeg-lillekorgus/2;
      int xkaugus=putukax-l.x;
      int ykaugus=putukay-(lilley-lillekorgus/2);
      if(!l.kasTyhi() && (xkaugus*xkaugus+ykaugus*ykaugus)<kauguseruut){
        l.paneTyhi(true);
        Toolkit.getDefaultToolkit().beep();
      }
    }
  }
  
  void joonistaLilled(){
    for(int i=0; i<lillekesed.size(); i++){
      Lilleke4 l=(Lilleke4)lillekesed.elementAt(i); 
      Image lillepilt=(l.kasTyhi())?lill2:lill;
      piltg.drawImage(lillepilt, l.x, aeg-l.algaeg-lillekorgus, this);
    }
  }

  
  
  public void start(){
    veel=true;
    new Thread(this).start();
  }

  public void run(){
    while(veel){
        repaint();
      try{Thread.sleep(paus); }catch(Exception e){}
    }
  }
  public void stop(){
    veel=false;
  }
  public void keyPressed(KeyEvent e){
    int kood=e.getKeyCode();
    if((kood==KeyEvent.VK_LEFT) && (putukax>putukasamm))putukax-=putukasamm;
    if((kood==KeyEvent.VK_RIGHT) && (putukax<laius-putukasamm-putukalaius))
        putukax+=putukasamm;
    if(kood==KeyEvent.VK_UP && putukay>putukasamm)putukay-=putukasamm;
    if(kood==KeyEvent.VK_DOWN && putukay<korgus-putukasamm-putukakorgus)
        putukay+=putukasamm;
  }
  public void keyReleased(KeyEvent e){}
  public void keyTyped(KeyEvent e){}
  Image laePilt(String failinimi){
     try{
      return getImage(getCodeBase(), failinimi);
     }catch(Exception e){}
      return Toolkit.getDefaultToolkit().getImage(failinimi);
  }

  public static void main(String argumendid[]){
    Frame f=new Frame("Pildiraam");
    Pildike4 ap=new Pildike4();
    f.add(ap);
    f.setSize(300, 300);
    f.setVisible(true);
    ap.start();
  }
}

