import javax.sound.midi.*;
public class Rada2{
 static int toonika=40;
 static int kiirus=50;
 static Sequence sekvents;
 static Track td[]=new Track[3];
 static int jd[]={0, 0, 0, 0, 1, 1, 0, 0, 2, 2, 1, 1, 0, 0, 0, 0}; //taktide duurid
 static int jnr=0;  //takti jrjekorranumber
 static void looKolmkola(Track t, int toonika){
  try{
   ShortMessage m[]=new ShortMessage[16];
   for(int i=0; i<m.length; i++){
     m[i]=new ShortMessage();
   } 
   m[0].setMessage(ShortMessage.PROGRAM_CHANGE, 0, 25, 0);
   m[1].setMessage(ShortMessage.NOTE_ON, 0, toonika, 60);
   m[2].setMessage(ShortMessage.NOTE_ON, 0, toonika+4, 60);
   m[3].setMessage(ShortMessage.NOTE_ON, 0, toonika+7, 60);
   m[4].setMessage(ShortMessage.NOTE_OFF, 0, toonika, 60);
   m[5].setMessage(ShortMessage.NOTE_OFF, 0, toonika+4, 60);
   m[6].setMessage(ShortMessage.NOTE_OFF, 0, toonika+7, 60);
    t.add(new MidiEvent(m[0], 0)); //pill
   for(int i=1; i<4; i++){
     t.add(new MidiEvent(m[i], (i-1)*4)); //noodid sisse
   }
   for(int i=4; i<7; i++){
     t.add(new MidiEvent(m[i], 12));  //lpus korraga vlja
   }
  }catch(Exception e){
    e.printStackTrace();
  }
 }
 public static void main(String argumendid[]) throws Exception{
         sekvents=new Sequence(Sequence.PPQ, 8);
         for(int i=0; i<3; i++){
           td[i]=sekvents.createTrack();
         }
         looKolmkola(td[0], 60);
         looKolmkola(td[1], 65);
         looKolmkola(td[2], 67);
         
         final Sequencer sequencer=MidiSystem.getSequencer();
         sequencer.open();
         sequencer.addMetaEventListener(
           new MetaEventListener(){
             public void meta(MetaMessage m){
              try{
               if(m.getType()==47){
                 sequencer.start();
                 sequencer.setTempoInBPM(kiirus);
                 sequencer.setTrackSolo(jd[(jnr>0)?jnr-1:jd.length-1], false);
                 sequencer.setTrackSolo(jd[jnr++], true);
                 if(jnr>=jd.length)jnr=0;
               }
              }catch(Exception e){
                e.printStackTrace();
              }
             }
           }
         );
         
         sequencer.setSequence(sekvents);
         sequencer.start();
         sequencer.setTempoInBPM(kiirus);
         sequencer.setTrackSolo(jd[jnr++], true);
  }
}
